within ;
package MOS3 
  model bouncingball 
    parameter Real g = 10;
    parameter Real c = 0.9;
    parameter Real h_init = 1;
    Boolean doskakali_jsme;
    Boolean x;
    Real h, v;
  initial equation 
    h = h_init;
    //doskakali_jsme = false;
  equation 
    doskakali_jsme = not x;
    when h < 0 then
      reinit(v, -v * c); 
    end when; 
    when h < (-1e-6) then
      reinit(v, 0);
      reinit(h, 0);
      x = true; 
    end when; 
    if doskakali_jsme then
      der(v) = 0; 
    else
      der(v) = -g;
    end if;
    der(h) = if doskakali_jsme then 0 else v;
    annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})));
  end bouncingball;
  
  connector pq 
    Real p;
    flow Real q;
    annotation(Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics={  Rectangle(origin = {-1, 2}, 
              fillPattern =                                                                                                    FillPattern.Solid, extent = {{-95, 94}, {95, -94}})}));
  end pq;
  
  model tlak 
    pq pq1 annotation(Placement(visible = true, transformation(origin = {90, -92}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {90, -92}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    parameter Real p;
  equation 
    pq1.p = p;
    annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})));
  end tlak;
  
  model komora 
    
    pq pq1 annotation(Placement(visible = true, transformation(origin = {0, -90}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {0, -90}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Blocks.Interfaces.RealInput c "compliance" annotation(Placement(visible = true, transformation(origin = {-86, 86}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-80, 78}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
    Real v "v jako vobjem";
    parameter Real v0 = 0 "initial vobjem";
  initial equation 
    v = v0;
  equation 
    pq1.p = c * v;
    der(v) = pq1.q;
    annotation(Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics={  Ellipse(origin=  {3, 5}, extent=  {{-49, 83}, {49, -83}}, endAngle=  360)}));
  end komora;
  
  model odpor 
    parameter Real r = 1;
    pq pq1 annotation(Placement(visible = true, transformation(origin = {-90, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-90, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    pq pq2 annotation(Placement(visible = true, transformation(origin = {80, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {80, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  equation 
    pq1.p - pq2.p = r * pq1.q;
    pq1.q + pq2.q = 0;
    annotation(Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics = {Rectangle(origin=  {-4, -5}, extent=  {{-64, 31}, {64, -31}})}));
  end odpor;
  
  model chlopen 
    pq pq1 annotation(Placement(visible = true, transformation(origin = {-84, 2}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-84, 2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    pq pq2 annotation(Placement(visible = true, transformation(origin = {86, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {86, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Real q;
    Real dp;
    Real s;
    Boolean on;
  equation 
    pq1.q + pq2.q = 0;
    pq1.p - pq2.p = dp;
    pq1.q = q;
    on = s > 0; 
    if on then
      dp = 0;
      q = s; 
    else
      dp = s;
      q = 0;
    end if;
    annotation(Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics = {Polygon(origin=  {-4, 0.0192121}, points=  {{-56, 79.9808}, {-56, -80.0192}, {44, -2.01921}, {44, -46.0192}, {56, -46.0192}, {56, 47.9808}, {42, 49.9808}, {44, 11.9808}, {-56, 79.9808}})}));
  end chlopen;
  
  model beatingHeart 
    tlak tlak1(p = 1) annotation(Placement(visible = true, transformation(origin = {-86, 4}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    odpor odpor1 annotation(Placement(visible = true, transformation(origin = {-60, 4}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    chlopen chlopen1 annotation(Placement(visible = true, transformation(origin = {-22, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    chlopen chlopen2 annotation(Placement(visible = true, transformation(origin = {30, 2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    tlak tlak2(p = 2) annotation(Placement(visible = true, transformation(origin = {80, 26}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    odpor odpor2 annotation(Placement(visible = true, transformation(origin = {68, 6}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    komora komora1 annotation(Placement(visible = true, transformation(origin = {12, 36}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Blocks.Sources.Sine sine1(freqHz = 1, offset = 0.51) annotation(Placement(visible = true, transformation(origin = {-50, 64}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  equation 
    connect(sine1.y, komora1.c) annotation(Line(points = {{-39, 64}, {2, 64}, {2, 42}, {2, 42}}, color = {0, 0, 127}));
    connect(odpor1.pq1, tlak1.pq1) annotation(Line(points = {{-69, 4}, {-68, 4}, {-68, -6}, {-76, -6}, {-76, -6}}));
    connect(odpor1.pq2, chlopen1.pq1) annotation(Line(points = {{-52, 4}, {-30, 4}, {-30, 0}, {-30, 0}}));
    connect(komora1.pq1, chlopen1.pq2) annotation(Line(points = {{12, 27}, {22, 27}, {22, 0}, {-14, 0}, {-14, 0}, {-14, 0}}));
    connect(chlopen2.pq1, chlopen1.pq2) annotation(Line(points = {{22, 2}, {-14, 2}, {-14, 0}, {-14, 0}}));
    connect(odpor2.pq1, chlopen2.pq2) annotation(Line(points = {{59, 6}, {38, 6}, {38, 2}, {38, 2}}));
    connect(tlak2.pq1, odpor2.pq2) annotation(Line(points = {{89, 17}, {96, 17}, {96, 6}, {76, 6}, {76, 6}}));
    annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})));
  end beatingHeart;
  annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), 
    uses(Modelica(version="2.2.2")));
end MOS3;
